( This is the 'classic' fixed-space bitmap font in glcdfont.c for Adafruit_GFX )
( Converted to GForth by Assad Ebrahim - 2021-05-29---Sat---16:06 )
 

42 constant star
: getfont-fwd ( n -- b1 b2 b3 b4 b5 ) 5 * rawfont + 5 0 do c@+ swap loop drop ;  \ reads in order (left to right) 
: getfont-rev ( n -- b5 b4 b3 b2 b1 )   \ reads in reverse into stack so display is easier
    1 + 5 * 1 - rawfont + 5 0 do c@- swap loop drop ;  
: .font 0> if 42 else bl then emit ;
: font init-mask begin 2dup and .font 1 rshift dup 0= until 2drop ;
: [showfont] ( b1 ... b5 -- ) 5 0 do cr font loop cr ;
: showfont ( n -- ) getfont-rev [showfont] ;
: showfontcomp  ( n -- ) dup emit showfont ;
\ rotate ccw 90 deg
: [rotfont] ( b1 b2 b3 b4 b5 )  7 0 do cr
    5 0 do 4 roll dup 1 j lshift and .font loop 
    loop cr 5 ndrop ;
: rotfont ( n -- ) getfont-fwd [rotfont] ;
: rotfontcomp  ( n -- ) dup emit rotfont ;

\ ex: 42 rotfontcomp
\ ex: 'A' rotfontcomp


\ ASCII 5x7 wxh pixel font, 5 bytes each, so 1.3kB of memory for the full ASCII 256 characters, and 0.7kB for 128 chars
\ these are rotated cw 90 degrees so need to unrotate them.  
\ why store this way?  to store them unrotated, would take more memory, 7 bytes using only 5 bits each, so X% less efficient
create rawfont  
	$00 c, $00 c, $00 c, $00 c, $00 c,
	$3E c, $5B c, $4F c, $5B c, $3E c,
	$3E c, $6B c, $4F c, $6B c, $3E c,
	$1C c, $3E c, $7C c, $3E c, $1C c,
	$18 c, $3C c, $7E c, $3C c, $18 c,
	$1C c, $57 c, $7D c, $57 c, $1C c,
	$1C c, $5E c, $7F c, $5E c, $1C c,
	$00 c, $18 c, $3C c, $18 c, $00 c,
	$FF c, $E7 c, $C3 c, $E7 c, $FF c,
	$00 c, $18 c, $24 c, $18 c, $00 c,
	$FF c, $E7 c, $DB c, $E7 c, $FF c,
	$30 c, $48 c, $3A c, $06 c, $0E c,
	$26 c, $29 c, $79 c, $29 c, $26 c,
	$40 c, $7F c, $05 c, $05 c, $07 c,
	$40 c, $7F c, $05 c, $25 c, $3F c,
	$5A c, $3C c, $E7 c, $3C c, $5A c,
	$7F c, $3E c, $1C c, $1C c, $08 c,
	$08 c, $1C c, $1C c, $3E c, $7F c,
	$14 c, $22 c, $7F c, $22 c, $14 c,
	$5F c, $5F c, $00 c, $5F c, $5F c,
	$06 c, $09 c, $7F c, $01 c, $7F c,
	$00 c, $66 c, $89 c, $95 c, $6A c,
	$60 c, $60 c, $60 c, $60 c, $60 c,
	$94 c, $A2 c, $FF c, $A2 c, $94 c,
	$08 c, $04 c, $7E c, $04 c, $08 c,
	$10 c, $20 c, $7E c, $20 c, $10 c,
	$08 c, $08 c, $2A c, $1C c, $08 c,
	$08 c, $1C c, $2A c, $08 c, $08 c,
	$1E c, $10 c, $10 c, $10 c, $10 c,
	$0C c, $1E c, $0C c, $1E c, $0C c,
	$30 c, $38 c, $3E c, $38 c, $30 c,
	$06 c, $0E c, $3E c, $0E c, $06 c,
	$00 c, $00 c, $00 c, $00 c, $00 c,
	$00 c, $00 c, $5F c, $00 c, $00 c,
	$00 c, $07 c, $00 c, $07 c, $00 c,
	$14 c, $7F c, $14 c, $7F c, $14 c,
	$24 c, $2A c, $7F c, $2A c, $12 c,
	$23 c, $13 c, $08 c, $64 c, $62 c,
	$36 c, $49 c, $56 c, $20 c, $50 c,
	$00 c, $08 c, $07 c, $03 c, $00 c,
	$00 c, $1C c, $22 c, $41 c, $00 c,
	$00 c, $41 c, $22 c, $1C c, $00 c,
	$2A c, $1C c, $7F c, $1C c, $2A c,
	$08 c, $08 c, $3E c, $08 c, $08 c,
	$00 c, $80 c, $70 c, $30 c, $00 c,
	$08 c, $08 c, $08 c, $08 c, $08 c,
	$00 c, $00 c, $60 c, $60 c, $00 c,
	$20 c, $10 c, $08 c, $04 c, $02 c,
	$3E c, $51 c, $49 c, $45 c, $3E c,
	$00 c, $42 c, $7F c, $40 c, $00 c,
	$72 c, $49 c, $49 c, $49 c, $46 c,
	$21 c, $41 c, $49 c, $4D c, $33 c,
	$18 c, $14 c, $12 c, $7F c, $10 c,
	$27 c, $45 c, $45 c, $45 c, $39 c,
	$3C c, $4A c, $49 c, $49 c, $31 c,
	$41 c, $21 c, $11 c, $09 c, $07 c,
	$36 c, $49 c, $49 c, $49 c, $36 c,
	$46 c, $49 c, $49 c, $29 c, $1E c,
	$00 c, $00 c, $14 c, $00 c, $00 c,
	$00 c, $40 c, $34 c, $00 c, $00 c,
	$00 c, $08 c, $14 c, $22 c, $41 c,
	$14 c, $14 c, $14 c, $14 c, $14 c,
	$00 c, $41 c, $22 c, $14 c, $08 c,
	$02 c, $01 c, $59 c, $09 c, $06 c,
	$3E c, $41 c, $5D c, $59 c, $4E c,
	$7C c, $12 c, $11 c, $12 c, $7C c,
	$7F c, $49 c, $49 c, $49 c, $36 c,
	$3E c, $41 c, $41 c, $41 c, $22 c,
	$7F c, $41 c, $41 c, $41 c, $3E c,
	$7F c, $49 c, $49 c, $49 c, $41 c,
	$7F c, $09 c, $09 c, $09 c, $01 c,
	$3E c, $41 c, $41 c, $51 c, $73 c,
	$7F c, $08 c, $08 c, $08 c, $7F c,
	$00 c, $41 c, $7F c, $41 c, $00 c,
	$20 c, $40 c, $41 c, $3F c, $01 c,
	$7F c, $08 c, $14 c, $22 c, $41 c,
	$7F c, $40 c, $40 c, $40 c, $40 c,
	$7F c, $02 c, $1C c, $02 c, $7F c,
	$7F c, $04 c, $08 c, $10 c, $7F c,
	$3E c, $41 c, $41 c, $41 c, $3E c,
	$7F c, $09 c, $09 c, $09 c, $06 c,
	$3E c, $41 c, $51 c, $21 c, $5E c,
	$7F c, $09 c, $19 c, $29 c, $46 c,
	$26 c, $49 c, $49 c, $49 c, $32 c,
	$03 c, $01 c, $7F c, $01 c, $03 c,
	$3F c, $40 c, $40 c, $40 c, $3F c,
	$1F c, $20 c, $40 c, $20 c, $1F c,
	$3F c, $40 c, $38 c, $40 c, $3F c,
	$63 c, $14 c, $08 c, $14 c, $63 c,
	$03 c, $04 c, $78 c, $04 c, $03 c,
	$61 c, $59 c, $49 c, $4D c, $43 c,
	$00 c, $7F c, $41 c, $41 c, $41 c,
	$02 c, $04 c, $08 c, $10 c, $20 c,
	$00 c, $41 c, $41 c, $41 c, $7F c,
	$04 c, $02 c, $01 c, $02 c, $04 c,
	$40 c, $40 c, $40 c, $40 c, $40 c,
	$00 c, $03 c, $07 c, $08 c, $00 c,
	$20 c, $54 c, $54 c, $78 c, $40 c,
	$7F c, $28 c, $44 c, $44 c, $38 c,
	$38 c, $44 c, $44 c, $44 c, $28 c,
	$38 c, $44 c, $44 c, $28 c, $7F c,
	$38 c, $54 c, $54 c, $54 c, $18 c,
	$00 c, $08 c, $7E c, $09 c, $02 c,
	$18 c, $A4 c, $A4 c, $9C c, $78 c,
	$7F c, $08 c, $04 c, $04 c, $78 c,
	$00 c, $44 c, $7D c, $40 c, $00 c,
	$20 c, $40 c, $40 c, $3D c, $00 c,
	$7F c, $10 c, $28 c, $44 c, $00 c,
	$00 c, $41 c, $7F c, $40 c, $00 c,
	$7C c, $04 c, $78 c, $04 c, $78 c,
	$7C c, $08 c, $04 c, $04 c, $78 c,
	$38 c, $44 c, $44 c, $44 c, $38 c,
	$FC c, $18 c, $24 c, $24 c, $18 c,
	$18 c, $24 c, $24 c, $18 c, $FC c,
	$7C c, $08 c, $04 c, $04 c, $08 c,
	$48 c, $54 c, $54 c, $54 c, $24 c,
	$04 c, $04 c, $3F c, $44 c, $24 c,
	$3C c, $40 c, $40 c, $20 c, $7C c,
	$1C c, $20 c, $40 c, $20 c, $1C c,
	$3C c, $40 c, $30 c, $40 c, $3C c,
	$44 c, $28 c, $10 c, $28 c, $44 c,
	$4C c, $90 c, $90 c, $90 c, $7C c,
	$44 c, $64 c, $54 c, $4C c, $44 c,
	$00 c, $08 c, $36 c, $41 c, $00 c,
	$00 c, $00 c, $77 c, $00 c, $00 c,
	$00 c, $41 c, $36 c, $08 c, $00 c,
	$02 c, $01 c, $02 c, $04 c, $02 c,
	$3C c, $26 c, $23 c, $26 c, $3C c,
	$1E c, $A1 c, $A1 c, $61 c, $12 c,
	$3A c, $40 c, $40 c, $20 c, $7A c,
	$38 c, $54 c, $54 c, $55 c, $59 c,
	$21 c, $55 c, $55 c, $79 c, $41 c,

